//          
//graflib.h       .

#include <stdlib.h> or #include<alloc.h>
#include <stdio.h>    //     
#include <string.h>   //      
#include <stdlib.h>
#include <conio.h>
#include "treelib.h"
#include "graflib.h"


void initialize_board(board b)
{
	//     (b)
   //         ""  OPEN
   //    FILLED
	int i,j,last;

   for (i=BOARD_MIN; i <= BOARD_MAX; i++)
   	for (j=BOARD_MIN; j <= BOARD_MAX; j++)
      	b[i][j]=OPEN;
   last=BOARD_SIZE - 1;
   for (i=0; i < BOARD_SIZE; i++)
   	b[0][i]=b[last][i]=b[i][0]=b[i][last]=FILLED;
};

void print_board(board b)
{
	int i,j;
   //    

   printf(" ");
   for (i=BOARD_MIN;i <= BOARD_MAX; i++)
   	printf("%d",i);
   for (i=BOARD_MIN; i<= BOARD_MAX; i++) {
   	printf("\n%d",i);
      for (j=BOARD_MIN; j<= BOARD_MAX; j++)
      	putchar(b[i][j]);
   }
   putchar('\n');
};

boolean valid_move(board b,int i,int j)
{
	//   TRUE    b[i][j]  
   //            
   // BOARD_MIN  BOARD_MAX      OPEN
   //         FILLED

	if (i < BOARD_MIN ||i > BOARD_MAX||j< BOARD_MIN||j> BOARD_MAX)
   	return FALSE;
   if (b[i][j]==OPEN && b[i+1][j]!=OPEN)
   	return TRUE;
   else
   	return FALSE;
};

void set_board(board b,int i,int j, player who)
{
	b[i][j]=who;
};


//           
//       .  
//         
// 
state *make_move(tree *p_T,int depth, player ply,int (*p_eval_f)(),int (*p_thisply_f)(),
							int (*p_nextply_f)())

{
	//     p_T.   depth, ply 
   //   , p_eval_f()   ,
   // p_thisply_f()   p_nextply_f      
   //       .

	static int thinkcount=0;
   state *p_currentstate, *p_nextstate;
   tree tmptree,childtree;
   state tmpstate;
   int i,j,value;

   p_currentstate=(state *)DATA(*p_T);
   if (depth==0||have_winner(BOARD(p_currentstate))==TRUE) {
   	VALUE(p_currentstate)=(*p_eval_f)(BOARD(p_currentstate));
      return NULL;
   }

   init_tree(&childtree);

   //    

   for (i=BOARD_MIN; i<=BOARD_MAX; i++) {
   	for (j=BOARD_MIN; j <= BOARD_MAX; j++) {
      	if (valid_move(BOARD(p_currentstate),i,j)==TRUE) {
         	if (++thinkcount %250==0) {
            	printf("Thinking...\n");
               thinkcount=0;
            }
            copy_board(BOARD(&tmpstate),BOARD(p_currentstate));
            set_board(BOARD(&tmpstate),i,j,ply);
            init_tree(&tmptree);

            //     configuration 
            //       .

            if (make_state_root(&tmptree,tmpstate,NULL,NULL)==ERROR)
            	return NULL;
            make_move(&tmptree,depth-1,other_player(ply),
            				p_eval_f,p_nextply_f,p_thisply_f);
            if (empty_tree(childtree)) {
            //    
            	childtree=tmptree;
               p_nextstate=(state *)DATA(tmptree);
               value=VALUE(p_nextstate);
            } else {
               //         "".

            	SIBLING(tmptree)=childtree;
               childtree=tmptree;

               //     

               if ((*p_thisply_f)(VALUE(DATA(tmptree)),value)) {
               	value=VALUE(DATA(tmptree));
                  p_nextstate=(state *)DATA(tmptree);
               }
            }
         }  // if (valid)
      } // for (j)
   }  // for (i)
   FIRST_CHILD(*p_T)=childtree;
   VALUE(p_currentstate)=value;
   return p_nextstate;
};

player other_player(player who)
{
	return (who==COMPUTER)?PLAYER:COMPUTER;
};


//         
//  .    
// .
int eval(board b)
{
	int i,j,thisvalue,valuesum;
   //     .   determine_value
   //           
   // .

   valuesum =0;
   for (i=BOARD_MIN; i<=BOARD_MAX; i++)
   	for (j=BOARD_MIN; j<=BOARD_MAX; j++) {
      	thisvalue=determine_value(b,i,j);
         if (ABS(thisvalue)==WIN) {
         	return thisvalue;
      }
      valuesum +=thisvalue;
   }
   return valuesum;
};

int determine_value(board b,int i,int j)
{
	//       b[i][j]
	#define HORIZ_LT 0
   #define HORIZ_RT 1
   #define VERT_UP 2
   #define VERT_DN 3
   #define DIAG_UPLT 4
   #define DIAG_UPRT 5
   #define DIAG_DNLT 6
   #define DIAG_DNRT 7
   #define SQAR_UPLT 8
   #define SQAR_UPRT 9
   #define SQAR_DNLT 10
   #define SQAR_DNRT 11
   	int value[12];
      int sum;
      int k;

      if (b[i][j]==OPEN)
      	return 0;

      for (k=0; k<12; k++)
      	value[k]=1;

      for (k=1;k<=3; k++) {
      	if (b[i+k][j]==b[i][j])
         	value [VERT_UP]++;
         else if (b[i+k][j]!=OPEN)
         	value[VERT_UP]=-10;

         if (b[i-k][j]==b[i][j])
         	value[VERT_DN]++;
         else if (b[i-k][j]!=OPEN)
         	value[VERT_DN]=-10;

         if (b[i][j+k]==b[i][j])
         	value[HORIZ_LT]++;
         else if (b[i][j+k]!=OPEN)
         	value[HORIZ_LT]=-10;

         if (b[i][j-k]==b[i][j])
         	value[HORIZ_RT]++;
         else if (b[i][j-k]!=OPEN)
         	value[HORIZ_RT]=-10;

         if (b[i+k][j+k]==b[i][j])
         	value[DIAG_DNRT]++;
         else if (b[i+k][j+k]!=OPEN)
         	value[DIAG_DNRT]=-10;

         if (b[i+k][j-k]==b[i][j])
         	value[DIAG_DNLT]++;
         else if (b[i+k][j-k]!=OPEN)
         	value[DIAG_DNLT]=-10;

         if (b[i-k][j+k]==b[i][j])
         	value[DIAG_UPRT]++;
         else if (b[i+k][j+k]!=OPEN)
         	value[DIAG_UPRT]=-10;

         if (b[i-k][j-k]==b[i][j])
         	value[DIAG_UPLT]++;
         else if (b[i+k][j-k] !=OPEN)
         	value[DIAG_UPLT]=-10;
      }

      if (b[i+1][j]==b[i][j]) {
      	value[SQAR_DNRT]++;
         value[SQAR_DNLT]++;
      } else if (b[i+1][j]!=OPEN) {
      	value[SQAR_DNRT]=-10;
         value[SQAR_DNLT]=-10;
      }

      if (b[i-1][j]==b[i][j]) {
      	value[SQAR_UPRT]++;
         value[SQAR_UPLT]++;
      } else if (b[i-1][j]!= OPEN) {
      	value[SQAR_UPRT]=-10;
         value[SQAR_UPLT]=-10;
      }

      if (b[i][j+1]==b[i][j]) {
      	value[SQAR_DNRT]++;
         value[SQAR_UPRT]++;
      } else if (b[i][j+1]!=OPEN) {
      	value[SQAR_DNRT]=-10;
         value[SQAR_UPRT]=-10;
      }

      if (b[i][j-1]==b[i][j]) {
      	value[SQAR_DNLT]++;
         value[SQAR_UPLT]++;
      } else if (b[i][j-1]!=OPEN) {
      	value[SQAR_DNLT]=-10;
         value[SQAR_UPLT]=-10;
      }

      if (b[i+1][j+1]==b[i][j])
      	value[SQAR_DNRT]++;
      else if (b[i+1][j+1]!=OPEN)
      	value [SQAR_DNRT]=-10;

      if (b[i+1][j-1]==b[i][j])
      	value[SQAR_DNLT]++;
      else if (b[i+1][j-1]!=OPEN)
      	value[SQAR_DNLT]=-10;

      if (b[i-1][j+1]==b[i][j])
      	value[SQAR_UPRT]++;
      else if (b[i-1][j+1]!=OPEN)
      	value[SQAR_UPRT]=-10;

      if (b[i-1][j-1]==b[i][j])
      	value[SQAR_UPLT]++;
      else if (b[i-1][j-1]!=OPEN)
      	value[SQAR_UPLT]=-10;

		//H          . 
      //   ,      
      //,     loop.

      for (sum=k=0;value[k]!=4 && k<12; k++)
      	if (value[k]>0)
         	sum +=value[k];

      if (k<12)
      	sum=WIN;
      return (b[i][j]==COMPUTER) ? -sum : sum;
};

boolean have_winner(board b)
{
	// TRUE   configuration   b   
   //    .  FALSE.
	int i,j,value;

   for (i=BOARD_MIN; i<=BOARD_MAX; i++)
   	for (j=BOARD_MIN; j<=BOARD_MAX; j++)
      	if (b[i][j]!=OPEN) {
         	value=determine_value(b,i,j);
            if (ABS(value)==WIN)
            	return TRUE;
         }
      return FALSE;
};


