//          
//      .
//       graflib.cpp

#ifndef _graf_h_ //   _graf_h_     
#define _graf_h_ //       .

#define BOARD_SIZE 8 // 
#define BOARD_MIN 1
#define BOARD_MAX 6

#define BOARD(p_S) (((state *)(p_S))->brd)
#define VALUE(p_S) (((state *)(p_S))->value)

#define COMPUTER 'O'
#define PLAYER 'X'
#define OPEN '-'
#define FILLED '+'
#define WIN 1000

#define FIRST_CHILD(T) LEFT(T)
#define SIBLING(T) RIGHT(T)

#define ABS(i) (((i)<0) ? (-i) : (i))

typedef char board[BOARD_SIZE][BOARD_SIZE];
typedef char player;

//           
//     .
typedef struct {
	int value;
   board brd;
} state;


//     
void initialize_board(board b);
void print_board(board b);
boolean valid_move(board b,int i,int j);
void set_board(board b,int i,int j, player who);
state *make_move(tree *p_T,int depth, player ply,int (*p_eval_f)(),int (*p_thisply_f)(),
							int (*p_nextply_f)());

player other_player(player who);
int eval(board b);
boolean have_winner(board b);
int determine_value(board b,int i,int j);


#endif