/* FOUR IN A ROW GAME
*       grid 6  6    
*        (,   ).
*          
*   .      
*             
*     "".
*/

#include <stdio.h>  //      
#include <string.h> //    .
#include <stdlib.h>
#include <conio.h>
#include "treelib.h"
#include "graflib.h"

int get_move(board b,player who);
int greater(int i,int j);
int less(int i, int j);

//          
//     .       
//           /.

main()
{
   tree T;
   state currentstate, *p_nextstate;
   int depth;

   initialize_board(BOARD(&currentstate));
   do {
   	printf("Enter game tree depth: ");
      scanf("%d",&depth);
   } while (depth<1);
   print_board(BOARD(&currentstate));

   while (get_move(BOARD(&currentstate),PLAYER)!=0) {
   	print_board(BOARD(&currentstate));
      if (have_winner(BOARD(&currentstate))==TRUE) {
      	printf("You win.\n");
         exit(0);
      }
      printf("Calculating my move...\n");
      init_tree(&T);
      if (make_state_root(&T,currentstate,NULL,NULL)==ERROR) {  
      	printf("Memory allocation error in main().\n");
         exit(-1);
      }
      p_nextstate=make_move(&T,depth,COMPUTER,eval,less,greater);
      if (p_nextstate==NULL) {
      	printf("Memory allocation error in move().\n");
         exit(-1);
      }
      printf("Board is now:\n");
      print_board(BOARD(p_nextstate));
      printf("Minimax value is %d\n",VALUE(p_nextstate));
      if (have_winner(BOARD(p_nextstate))==TRUE) {
      	printf("I win.\n");
         exit(0);
      } else if (VALUE(p_nextstate)==WIN) {
      	printf("I concede.\n");
         exit(0);
      }
      copy_board(BOARD(&currentstate),BOARD(p_nextstate));
      destroy_tree(&T,free);
   }
}

int get_move(board b,player who)
{
	int row,col;
   while(1) {
   	printf("Enter row col of your move (0 0 to quit):");
      scanf("%d%d",&row,&col);
      if (row==0 && col==0)
      	return 0;
      if (valid_move(b,row,col)==TRUE) {
      	set_board(b,row,col,who);
         return 1;
      }
      printf("Invalid move.\n");
   }
};

int greater(int i,int j)
{
	return i>j;
};

int less(int i, int j)
{
	return i<j;
};

//           
//.          make_move.
