//         
//    .     
// treelib.cpp

#ifndef _tree_h_    //       
#define _tree_h_   //          
                  //      

#define TRUE 1    //    
#define FALSE 0
#define ERROR 0
#define OK 1

#define DATA(T) ((T)->datapointer)
#define LEFT(T) ((T)->left)
#define RIGHT(T) ((T)->right)

typedef void*  generic_ptr ;
typedef int  status ;
typedef int  boolean ;

//      :    
//    .     .

typedef struct tree_node tree_node,*tree;

struct tree_node {
	generic_ptr datapointer;
   tree left;
   tree right;
};

typedef enum {PREORDER,INORDER,POSTORDER } ORDER;

//        
// .
status allocate_tree_node(tree *p_T,generic_ptr data);
void free_tree_node(tree *p_T);
status init_tree(tree *p_T);
boolean empty_tree(tree T);
status make_root(tree *p_T,generic_ptr data, tree left,tree right);
void destroy_tree(tree *p_T,void (*p_func_f)());
status traverse_tree(tree T,status (*p_func_f)(),ORDER order);
static status preorder_traverse(tree T,status(*p_func_f)());
static status inorder_traverse(tree T,status (*p_func_f)());
static status postorder_traverse(tree T,status (*p_func_f)());


#endif